@echo off

SET init_dir=%cd%

IF [%1] == [-i] (
    IF [%2] == [] (
        ECHO Error: instance key is passed but instance is not defined. Exiting...
        TIMEOUT 5 > NUL
        EXIT /B
    )
    SET gl_instance=%2
) ELSE (
    SET gl_instance=-1
)

IF [%gl_instance%] == [-1] (
    SET gl_instance_str=default_instance
) ELSE (
    SET gl_instance_str=instance_%gl_instance%
)

ECHO INSTANCE %gl_instance_str% WILL BE LAUNCHED.

ECHO:
ECHO ===== LAUNCHING IRZ REMOTE SERIAL PORT SERVER =====
SET gl_binary_str=remote-serialport-server
CD %init_dir%
CD remote-serialport-server
CALL .\launch.bat -i %gl_instance%
TIMEOUT 5 > NUL
CALL :CheckIfLaunched
IF %ERRORLEVEL% NEQ 0 (
    EXIT /B %ERRORLEVEL%
)

ECHO:
ECHO ===== LAUNCHING IRZ RADAR-24 SERVER =====
SET gl_binary_str=radar24-server
CD %init_dir%
CD radar24-server
CALL .\launch.bat -i %gl_instance%
TIMEOUT 5 > NUL
CALL :CheckIfLaunched
IF %ERRORLEVEL% NEQ 0 (
    EXIT /B %ERRORLEVEL%
)

ECHO:
ECHO ===== LAUNCHING IRZ RADAR-24 JSON ADAPTER =====
SET gl_binary_str=radar24-json-adapter
CD %init_dir%
CD radar24-json-adapter
CALL .\launch.bat -i %gl_instance%
TIMEOUT 5 > NUL
CALL :CheckIfLaunched
IF %ERRORLEVEL% NEQ 0 (
    EXIT /B %ERRORLEVEL%
)

TIMEOUT 5 > NUL
EXIT /B 0


:CheckIfLaunched
SET gl_window_title_str=%gl_binary_str%-%gl_instance_str%
SET "result="
tasklist /v /fo list /fi "WindowTitle eq %gl_window_title_str%"
FOR /F "tokens=1 delims= " %%T IN ('tasklist /fo table /fi "WindowTitle eq %gl_window_title_str%"') DO (
    IF /I [%%T] == [powershell.exe] (
        SET result=%gl_window_title_str%
    )
)

IF [%result%] == [] (
    ECHO Failed.
    EXIT /B 1
) ELSE (
    ECHO Done.
    EXIT /B 0
)
