param([Int32]$instance=-1)

$binary_str = "radar24-json-adapter"
$max_restarts = 25

if ($instance -eq -1) {
    $instance_str = "default_instance"
    $config_file = "default_config.json"
} else {
    $instance_str = "instance_" + $instance.ToString()
    $config_file = $instance_str + "_config.json"
}

$window_title_str = $binary_str + "-" + $instance_str
$nostart_file_str = ".\nostart-" + $instance_str
$exec_params = '-c', $config_file

Write-Host ("Instance is " + $instance_str + ".")

$host.ui.RawUI.WindowTitle = $window_title_str

$num_restarts = 0
while ($true) {
    if (Test-Path -PathType Leaf -Path $nostart_file_str) {
        Write-Host ("Nostart file found. Exiting...")
        Exit
    }

    Write-Host ("Working (infinite loop until terminated)...")
    & .\$binary_str $exec_params
    Write-Host ("Process finished with error, terminated or crashed.")

    $num_restarts++
    if ($num_restarts -ge $max_restarts) {
        Write-Host ("Finish/terminate/crash occurrence count has exceeded it's limit. Exiting...")
        Exit
    }
}
