param([Int32]$instance=-1)

$binary_str = "remote-serialport-server"
$instance_0_port = 7600
$instance_d_port = 7678
$max_restarts = 25

if ($instance -eq -1) {
    $instance_str = "default_instance"
    $config_port = $instance_d_port
} else {
    $instance_str = "instance_" + $instance.ToString()
    $config_port = $instance_0_port + $instance
}

$window_title_str = $binary_str + "-" + $instance_str
$nostart_file_str = ".\nostart-" + $instance_str
$exec_params = '-p', $config_port.ToString()

Write-Host ("Instance is " + $instance_str + ".")
Write-Host ("Selected port is " + $config_port.ToString() + ".")

$host.ui.RawUI.WindowTitle = $window_title_str

$num_restarts = 0
while ($true) {
    if (Test-Path -PathType Leaf -Path $nostart_file_str) {
        Write-Host ("Nostart file found. Exiting...")
        Exit
    }

    Write-Host ("Working (infinite loop until terminated)...")
    & .\$binary_str $exec_params
    Write-Host ("Process finished with error, terminated or crashed.")

    $num_restarts++
    if ($num_restarts -ge $max_restarts) {
        Write-Host ("Finish/terminate/crash occurrence count has exceeded it's limit. Exiting...")
        Exit
    }
}
